'''
Created on Feb 9, 2015

@author: rado
'''


from basesoft.web.contrib.file.models import File

from basesoft.web.contrib.notification.models import Notification
from django.utils.translation import ugettext, ugettext_lazy as _


class WeDeclarationFile(File):
    """
    @DynamicAttrs
    """
    STATUS_UNPROCESSED = 1
    STATUS_PROCESSED = 2

    def __repr__(self):
        return '<WeDeclarationFile file_name="%s" hqpp_id="%s">' % (self.file_name, self.hqpp_id)

class WeDeclaration(object):
    """
    @DynamicAttrs
    """
    STATUS_COMPLETE = 1
    STATUS_EXPORTED = 2

    def __repr__(self):
        return '<WeDeclaration id="%s" file_id="%s" lpp_id="%s">' % (self.id, self.file_id, self.lpp_id)


class WeDeclarationLine(WeDeclaration):
    """
    @DynamicAttrs
    """

    def __repr__(self):
        return '<WeDeclarationLine index="%s" declaration_id="%s">' % (self.position, self.declaration_id)


class WeDeclarationReminderNotification(Notification):
    name_i18n = _('Declaration reminder')

    def get_message(self):
        return ugettext("There are no declarations for the latest "
                 "take-back scheme period. Please, make sure you have "
                 "declared before the closing day.")

    def get_subject(self):
        return ugettext('Declaration reminder')

    def __repr__(self):
        return '<WeRegulationPeriodNotification id=%s>' % self.id