# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.
import os

from basesoft.web.contrib.license.models import RoleConfig
from we.product.importers import CN8CsvImporter
from we.product.models import WeCN8


def post_sync(sa_session, app_name):
    if app_name != 'iqportal.weee.core':
        return

    # if the test app is enabled for WEEE Europe we remove any account configs from the roles
    # this way we can still use the icon bar for selenium testing
    q = sa_session.query(RoleConfig).filter(RoleConfig.is_license==False)
    for config in q:
        sa_session.delete(config)

    cn8_codes = sa_session.query(WeCN8).all()

    if len(cn8_codes) == 0:
        # CN8 code CSV import
        csv_file_path = os.path.join(os.path.dirname(__file__), 'files', 't_cn8.csv')

        importer = CN8CsvImporter(sa_session)
        importer.import_file(csv_file_path, None)