'''
Created on Dec 17, 2014

@author: marten
'''
from decimal import Decimal

from datetime import date

from basesoft.util.virtual_date import set_date
from we.product.models import WeCN8
from we.test.selenium.we_selenium import WeSeleniumTestCase

class TestCase(WeSeleniumTestCase):
    """
    The Operator license + admin account is created by sysadmin
    """
    def setUp(self):
        super(TestCase, self).setUp()

        self.connect_db()

        self._operator_account = self._create_operator_account()

    def test_create_operator_additional_account(self):
        # create new group on Operator license (sysadmin)

        # limit permissions (from role)

        # create new account within limited group.

        # activate account from activation link

        # login with new account.
        pass

    def test_product_sheet_as_operator(self):
        """
        Test that the operator sees all HQPPs products
        """
        set_date(date(2015, 5, 5))
        # add HQPP
        member, lpp, tbs_product_level, tbs = self.create_lpp()

        code = self.sa_session.query(WeCN8).first()

        categories = [{
            'id': tbs_product_level.id,
            'fee': Decimal('20.12')
        }]
        rp = self.create_tbs_regulation_period(tbs.id, self._uniquestring('RP'), 2015, 1, categories)

        self.add_hqpp_product(member.id, tbs_product_level.id, code.code, 'RRT344598')

        # add a second HQPP
        member1, lpp1, tbs_product_level1, tbs1 = self.create_lpp()

        code = self.sa_session.query(WeCN8).first()

        categories = [{
            'id': tbs_product_level1.id,
            'fee': Decimal('20.12')
        }]
        rp1 = self.create_tbs_regulation_period(tbs1.id, self._uniquestring('RP'), 2015, 1, categories)

        self.add_hqpp_product(member1.id, tbs_product_level1.id, code.code, 'UTY583473')

        self.login(self._operator_account.name, 'test_password')

        self.click_iconbar('icon-we-hqpp-product-manager', 'icon-we-member-manager')
        self.wait_for_loading()

        # filter CQ
        self.filter_cq(panel_name='we_hqpp_product_manager', filters=[('Producer', 'Equal',
                                                                       ('multiple', (('input_text', member.company.name),
                                                                                     ('input_text', member1.company.name))))])

        # check that manager shows 2 rows
        l = self.cq_rows_length(panel_name='we_hqpp_product_manager')
        self.assertEqual(l, 2)