'''
Created on Dec 17, 2014

@author: marten
'''
from we.test.selenium.we_selenium import WeSeleniumTestCase

class TestCase(WeSeleniumTestCase):

    def setUp(self):
        super(TestCase, self).setUp()
        self.connect_db()
        self._operator_account = self._create_operator_account()
        self.reset_vat()

    def test_save_and_update_tbs(self):
        # login as operator admin
        self.login(self._operator_account.name, 'test_password')

        # open TBS manager
        self.click_iconbar('icon-we-tbs-manager')
        self.wait_for_loading()

        # open creation panel
        self.click_menu(panel_name='we-tbs-manager', text='Create TBS')
        self.wait_for_loading()

        tbs_name = self._uniquestring('TBS')[:20]

        forms_data = {
            'company_form': {
                'name': tbs_name,
                'website': 'http://tbs.com',
                'vat_no': 'BE0893027827'
            },
            'bank_account_form': {
                'iban': "IL620108000000099999999",
                'bic': "DEUTDEFF",
                'number': "324234234",
            },
            'address_form': {
                'street': 'TBS Street',
                'city': 'Amsterdam',
                'postcode': '1000AA',
                'country': ('select', 'Netherlands'),
                'state': 'NH'
            },
            'person_form': {
                'first_name': 'TBS First Name',
                'last_name': 'TBS Last Name',
                'email': 'tbs-test@mail-test.basesoft.com',
                'preferred_locale': ('select', 'English'),
                'gender': ('select', 'Female'),
                'phone': '3459764356',
                'mobile_phone': '3459764356'
            }
        }

        # fill form
        self.fill_forms(panel_name='we-tbs-details', forms_data=forms_data)

        self.click_button(panel_name='we-tbs-details', text='Save')
        self.wait_for_loading()

        self.close_panel('we-tbs-manager')

        self.click_iconbar('icon-we-tbs-manager')
        self.wait_for_loading()

        self.filter_cq(panel_name='we-tbs-manager', filters=[
            ('Name', 'Equal', tbs_name),
        ])
        self.click_cq(panel_name='we-tbs-manager', row_index=0, col_name='license_name')
        self.wait_for_panel('we-tbs-details')
        self.wait_for_loading()

        self.assert_forms(panel_name='we-tbs-details', forms_data=forms_data)

        forms_data['person_form']['last_name'] = 'UPDATED Last Name'

        self.fill_forms(panel_name='we-tbs-details', forms_data={'person_form':{'last_name': forms_data['person_form']['last_name']}})

        self.click_button(panel_name='we-tbs-details', text='Save')
        self.wait_for_loading()

        self.close_panel('we-tbs-manager')

        self.click_iconbar('icon-we-tbs-manager')
        self.wait_for_loading()

        self.filter_cq(panel_name='we-tbs-manager', filters=[
            ('Name', 'Equal', tbs_name),
        ])
        self.click_cq(panel_name='we-tbs-manager', row_index=0, col_name='license_name')
        self.wait_for_panel('we-tbs-details')
        self.wait_for_loading()

        self.assert_forms(panel_name='we-tbs-details', forms_data=forms_data)

    def test_create_tbs_additional_account(self):
        # open license manager

        # add new account for TBS group

        # open link from account activation

        # login.
        pass

    def test_tbs_index_widget(self):
        # login as TBS user and check if we can view this declaration
        tbs = self._create_tbs(self._operator_account)
        tbs_account = self._create_tbs_account(tbs)
        self.login(tbs_account.name, 'test_password')

        self.expand_layout_pane(0)
        self.click_palette('Mode')
        self.click_palette('Compose')
        self.wait_for_loading()

        self.click_palette('Navigation', palette_index=2)

        # drag widgy
        self.drag_item_from_palette('Navigation widget', block_index=0, column_index=0)
        self.wait_for_loading()
